/****
LatinHCDesign Class - 6/19/00 cmsief
Derived from InitialDesign
****/

#ifndef _MAPS_ID_LHC_
#define _MAPS_ID_LHC_

#include "maps_general.h"
#include "InitialDesign.h"

class LatinHCDesign: public InitialDesign {

public:
  LatinHCDesign();
  /*default constructor*/

  LatinHCDesign(long dim);
  /*sets the dimension of the space*/

  LatinHCDesign(const LatinHCDesign &I);
  /*copy constructor*/
  
  ~LatinHCDesign();
  /*destructor*/
  
  bool GenerateDesign(const Bounds &b, long num_points);
  /****
   INPUT: The problem's bounds, the number of points to put in the design, and
   the grid.
   OUTPUT: Returns true if the operation was successful.
   EFFECTS: Generates the initial design via latin hypercubes.  Then calls
   InitialDesign's GenerateDesign.
  ****/

  void PutStream(long st);
  /**
     Change the random stream before generating design
  **/

private:
  long stream;
  
};/*end class*/

#endif

