/****
NullApprox Class - 8/1/00 cmsief
This is an derived class from Approximate.
Fully implemented in the header:)
****/
#ifndef _MAPS_NULL_APPROX_
#define _MAPS_NULL_APPROX_

#include "maps_general.h"
#include <iostream>
#include "Approximate.h"

using namespace std;

class NullApprox: public Approximate {

public:
  NullApprox():Approximate(){;}
  NullApprox(long dim):Approximate(dim){;}
  NullApprox(NullApprox &N):Approximate(N){;}
  ~NullApprox(){;}
  NullApprox& operator=(Approximate &A)
    {if(A.GetType()==A_NULL_APPROX) *this=(NullApprox&) A;
     return *this;}

  NullApprox& operator=(NullApprox &N){P=N.P; return(*this);}
  /*****QUERY FUNCTIONS*****/

  long GetType() const {return A_NULL_APPROX;}
  /****
  OUTPUT: returns the proper code for type of approximation
  ****/     
  
  void debug(char *code) const {cout<<code<<"  NullApprox::debug() P="<<P<<"\n";}
  /****
  EFFECT: Outputs a state dump     
  ****/

  /****ACTION FUNCTIONS*****/
  
  bool EvaluateApprox(const mp_vector &x, const pt_collect &Eval_c, double* Approx,
                double* D_c) {(*Approx)=0; (*D_c)=0;return true;}
  /****
  INPUT: The location to evaluate at, the location of evaluated sites, and two
  double pointers for return values.
  OUTPUT: Always returns true;
  EFFECT: Returns 0 for both
  ****/
  
  bool UpdateApprox(pt_collect &Eval_c, mp_vector& f_values, long
                    numpoints, double delta, const Bounds &b){return true;}
  /****
  INPUT: The collection of evaluated sites, their values, the number of points
  evaluated, the iteration number, delta and the bounds.
  OUTPUT: Always returns true.
  EFFECT: Nothing.
  ****/

};/*end class*/

#endif
