# mdat2tex.awk script - 6/17/99
# converts MAPS <iteration history>.dat files to tex tables
# Chris Siefert, College of William and Mary


BEGIN { FS=" "; tabNum=-1; printf "%% autogenerated tables \n" }

# handles beginning of a table, by outputting comments, and the necessary 
# commands to start the table 
$1 ~ /NUM/ {
  tabNum++
  printf "%% From file: " FILENAME ", this is table #" tabNum  "\n"
  printf "\\begin\{center\}\\begin\{tabular\}\{c|" 
  for(i=1; i<NF-1; i++) printf "r|"
  printf "r\}\n"   #deal with last element separately
  
  printf "\\textbf\{Iteration\} &"
  for(i=2; i<NF; i++) printf "\\textbf\{$x_%s$\} &",$i
  i=NF
  printf "\\textbf\{Value\}\\\\ \n\\hline \n"

}

# takes care of the end of a table, and the best value below
$1 ~ /Best/ { 
  printf "\\end\{tabular\}\\end\{center\}\n" 
  printf "\\begin\{center\} " $1 " " $2 " is \\" $5 " " $6 " " $7 "\n\\end\{center\}\n\n" 
}

# output the table elements in correct format
$1 !~ /^[[:alpha:] | # | \*]/  { 
  if($0 != "") {  #this prevents an excess \\ for blank lines
        for(i=1;i<NF; i++) printf $i "& "
	i=NF
        printf $i "\\\\ \n"  #last element separate
  }
}

END { printf "%% finished autogenerated tables \n" }
