/* sample2.cc
   Sample file for use with testClassic interface
   for MAPS.
   Chris Siefert  July, 2000
*/

#include "testClassic.h"
#include "f2c.h"

/* Table of constant values */

static integer c__2 = 2;
static integer c__20 = 20;

int mfcn(long dim, double *point, double * val)
{
    /* System generated locals */
    bool ret_val;
    double x=point[0], y=point[1];
    
    /* Parameter adjustments */
    --point;

    /* Function Body */
    /*This function is "Simulated Annealing I" from
      Bohachevsky, Johnson and Stein 1986
      (as seen in Cox & John 1997)
    */
    
    *val=2*sqr(x) + 2*sqr(y) -0.3*cos(3.0*M_PI*x) - 0.4*cos(4.0*M_PI*y) +0.7;
  
    ret_val = 1;
    return ret_val;
} /* mfcn_ */



/* Main program */int  main()
{
    static doublereal a[2], b[2];

    a[0] = (float)-1.;
    a[1] = (float)-1.;
    b[0] = (float)1.;
    b[1] = (float)1.;

    setbound(c__2, a, b);
    b[0] = (float).5;
    b[1] = (float).5;

    msearch(c__2, b,c__20,-1);
    return 0;
} /* MAIN__ */









