/***************************
 MAPS testClassic interface
 Chris Siefert 7/13/00                            
 ***************************/
#include "testClassic.h"
#include "MultiCompassSearch.h"

Bounds b;
bool bounds_set=false;

void setbound(long DIM, double * lower, double * upper){
  b.lower.newsize(DIM); b.upper.newsize(DIM);
  for(long i=0;i<DIM;i++){
    b.lower[i]=lower[i];b.upper[i]=upper[i];
  }/*end for*/
  bounds_set=true;
}/*end set_bounds*/

bool msearch(long DIM, double * initial_guess, long max_fevals, double tol){
  
  bool s1,s2,s3,s4,s5;
  PSGrid *g;
  char fn[2] = " ";
  if(!bounds_set) return false;
  
  if(PATTERN_SEARCH_DELTA != -1){
    mp_vector res(DIM);
    res=PATTERN_SEARCH_DELTA;//assign to all elements
    g=new PSGrid(DIM,b,res);
  }/*end if*/
  else{
    /*default*/
    g=new PSGrid(DIM,b);
  }/*end if*/
  
  LatinHCDesign LHC1(DIM);
  LHC1.GenerateDesign(b,INITIAL_DESIGN_BUDGET,*g, 0);
   
  maps M(max_fevals,DIM,b,fn);

  if(initial_guess!=NULL){
    mp_vector t2(DIM,initial_guess);
    M.NewInitialPoint(t2);
  }/*end if*/
  
  if(tol>0) TOLERANCE=tol;
  
  KrigApprox KA(DIM);
  if(CORRELATION!=DEFAULT)
    KA.ResetCorrelationFamily(CORRELATION);  
  if(ESTIMATED_TREND==1)
    KA.ResetEstimateQuadraticTrend();
  SearchCriterion SC(KA,b);

  mp_vector temp(DIM);temp=0;
  CompassSearch CS(DIM,temp);
  MultiCompassSearch MCS(DIM,temp);    
  MCS.ResetParams(10,-1,41,b);
  
  mp_vector bestpt(DIM);
  double bestval;

 
  if(PATTERN_SEARCH==0) s1=M.ResetPatternSearch(CS);
  else if(PATTERN_SEARCH==1) s1=M.ResetPatternSearch(MCS);
    
  s2=M.ResetDesign(LHC1);
  s3=M.ResetSearchCriterion(SC);
  s4=M.ResetGrid(*g);

  s5=M.RunMAPS();
  M.RetrieveBestSeen(&bestpt,&bestval);
  M.GenerateIterationHistory();

  cout<<"Bestval="<<setw(10)<<bestval<<endl;
  
  delete g;
  return true;
}/*end maps_search*/


