/***************************
 MAPS testClassic interface
 Chris Siefert 7/13/00                            
 ***************************/


#ifndef _MAPS_TEST_CLASSIC_
#define _MAPS_TEST_CLASSIC_
#include "maps.h"
#include "maps_general.h"
#define DEFAULT -1


#define RANDOM_SEED 123456789
#define RUNS_OF_MAPS 1
#define INITIAL_DESIGN_BUDGET 10
#define CORRELATION DEFAULT          /*default*/
#define PATTERN_SEARCH_DELTA DEFAULT /*default*/
#define PATTERN_SEARCH 1             /*Compass=0, MultiCompass=1*/
#define ESTIMATED_TREND 0            /*Constant=0, Quadratic=1*/

/*The objective function which you define elsewhere*/
extern int mfcn(long DIM, double * x, double *f);

void setbound(long DIM, double * lower, double * upper);
bool msearch(long DIM, double * initial_guess, long max_fevals, double tol);
/*
  Set initial_guess to NULL for MAPS to make its own guess.
  Set tol to -1 for default tolerance.
*/

#endif
